/*****************************************************************
 * mailall v1.0                                    (c) 3xT [1997]* 
 * coded by Satanic HamPster / awacs [3xT]                       *
 *****************************************************************
 *  Platform(s): linux , *unix                                   *
 *   Catagories: utility / user management / user admin          *
 *  Description: Mails all local users contents of a specified   *
 *               file.						 *
 *****************************************************************
 * Revision Table:                                               *
 * v1.0		8.11.97		Initial release			 *
 *****************************************************************
 * Things to do:						 *
 *  make man page  ??? 					 *
 *****************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <pwd.h>
#include <sys/types.h>
#include <strings.h>

struct passwd info, *z;
#ifndef NO_SHADOW
struct spwd info_shad, *x;
#include <shadow.h>
#endif
char tempbuf[80], filename[255];
FILE *fp;
int binary, quiet =0;
unsigned int i;
int main(int argc, char *argv[]){


char* maxi_pad_left(unsigned int width, char *string) {
/* Pads output of username for straight columns */
	unsigned int i;
	if(strlen(string) >= width) return (string);
	for(i=strlen(string); i<width; i++) string[i] = ' ';
	string[width]='\0';
	return (string);
	}



void mail_user(char *user) {
	if(quiet != 1)printf("[%s]\n", info.pw_name);
	if(binary == 1) {
		strcpy(tempbuf, "uuencode ");
		strcat(tempbuf, filename);
		strcat(tempbuf, " ");
		strcat(tempbuf, filename);
		strcat(tempbuf," | mail ");
		strcat(tempbuf,user);
	}
	else {
		strcpy(tempbuf, "mail ");
		strcat(tempbuf, user);
		strcat(tempbuf, " < ");
		strcat(tempbuf, filename);
	}
	system(tempbuf);		
}
void retard_help() {
	/* Thought this would be better than repeating this block 2x */
	printf("\nmailall v1.0 (c) -=3xT=- [1997]\n");
        printf("---------------------------------\n");
	printf("Usage: mailall -<options> <file>\n");
	printf("<options>: b (binary) uuencode file first\n");
	printf("         : q quiet\n");
	printf("         : h help\n");
}

/* Real beginning of MAIN */

	/* Make sure either 2 or 3 arguments have been entered */
	if(argc<2 || argc>3){
	    printf("Usage: mailall -bhq <file>\n");
	    return 1; 
	}
	/* If executed w/ options, process them and cpy argv[2] to filename */
	if(argc == 3 && argv[1][0] == '-') {
		for(i=1;i<(strlen(argv[1]));i++) {
			switch(argv[1][i]) {
				case 'b' : {
					binary = 1;
					break;
				}
				case 'q' : {
					quiet  = 1;
					break;
				}
				case 'h' : retard_help();	
					
			}
		}
		strcpy(filename, argv[2]);	
	}
	/* if executed  with 1 argument, do this */
	if(argc == 2) {
		if(!strcmp(argv[1], "-h")) {
			retard_help();
			return(0);
		}
		else strcpy(filename, argv[1]);
	}


	/* Open the file and install secret backdoors :) */
	if( (fp = fopen(filename, "r")) == NULL) {
		printf("Error opening %s\n", argv[1]);
		return 1;
	}
	

	fclose(fp);

	if(quiet != 1) printf("  mailing users . . .\n");

	z = getpwent();

#ifndef NO_SHADOW
	x = getspent();
#endif	
#ifdef NO_SHADOW
	while (z != NULL) {
#endif 
#ifndef NO_SHADOW
	while ((z != NULL) || (x != NULL)) {
#endif
		info=*z;
#ifndef NO_SHADOW 
		info_shad=*x;
#endif
		if(!strcmp(info.pw_passwd,"*")) { 
			if(quiet != 1) printf("[%s - LOCKED in /etc/passwd, (skipping)\n", maxi_pad_left(15,strcat(info.pw_name,"]")));
		}
		else {
#ifndef NO_SHADOW			
			if(!strcmp(info_shad.sp_pwdp,"*")) {
				if(quiet != 1) printf("[%s - LOCKED in /etc/shadow, (skipping)\n", maxi_pad_left(15,strcat(info.pw_name,"]")));
			}
#endif
#ifndef NO_SHADOW
			else mail_user(info.pw_name);
#endif
#ifdef NO_SHADOW
			mail_user(info.pw_name);
#endif
		}
		z = getpwent();
#ifndef NO_SHADOW
		x = getspent();
#endif 
	}
	if(quiet != 1) printf("  completed\n");
	return(0);
}
